{$M 30000,0,655360 }
(**************************************************
 *                                                *
 *    Morseuebungsgenerator V1.0                  *
 *                                                *
 *    Letzte Aktualisierung: 02.08.89  16:00      *
 *                                                *
 *    Turbopascal 4.0 oder 5.5                    *
 *                                                *
 **************************************************)

program CWTutor;


uses Crt,Printer,Dos;


(*************************************************************************)
(*                                                                       *)
(*                Deklaration der Variablen/Const.                       *)
(*                                                                       *)
(*************************************************************************)

var Frequenz,
    Anzahl,
    Abstand,Lektion,
    Geschwindigkeit,Geschw : integer;
    Zeichen                : array [1..400] of char;
    Auswahl                : set of char;
    speichern              : Boolean;


(*************************************************************************)
(*                                                                       *)
(*                  Einschalten des normalen Cursors                     *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE cursor_an;
BEGIN
  inline($b4/$01/
         $b9/$0b0c/
         $cd/$10);
END;


(*************************************************************************)
(*                                                                       *)
(*                  Ausschalten des Cursors                              *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE cursor_aus;
BEGIN
  inline($b4/$01/
         $b9/$2000/
         $cd/$10);
END;



(*************************************************************************)
(*                                                                       *)
(*            Fenster mit Rahmen ffnen / bergeben der Koord.           *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE F_Window(xl,yl,xr,yr : integer);
var Laenge, Breite,i : integer;
BEGIN
  window(xl,yl,xr,yr);
  Textbackground(Black);
  Textcolor(Red);
  highvideo;
  Breite := abs(xl-xr);
  Laenge := abs(yl-yr);
  for i := 1 to (Breite-2) do BEGIN
    gotoxy(i+1,1);write(#205);
    gotoxy(i+1,laenge);write(#205);
  END;
  for i := 1 to (Laenge-2) do BEGIN
    gotoxy(1,(i+1));write(#186);
    gotoxy(Breite,(i+1));write(#186);
  END;
  gotoxy(Breite,Laenge);write(#188);
  gotoxy(1,1);write(#201);
  gotoxy(Breite,1);write(#187);
  gotoxy(1,Laenge);write(#200);
  window((xl+1),(yl+1),(xr-2),(yr-2));
END;



(*************************************************************************)
(*                                                                       *)
(*                  Tonhhe zeigen                                       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Tonhoehe;
BEGIN
  F_Window(4,13,24,18);
  TextColor(White);
  LowVideo;
  ClrScr;
  writeln('     Tonhhe: ');
  writeln;
  write  ('     ',Frequenz,' Hz');
END;


(*************************************************************************)
(*                                                                       *)
(*                  Geschwindigkeit zeigen                               *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Geschwindigkeit;
BEGIN
  F_Window(4,18,24,23);
  TextColor(White);
  LowVideo;
  ClrScr;
  writeln(' Geschwindigkeit: ');
  write  ('      ', Geschw,' WpM    ');
  Geschwindigkeit := Trunc(1/Geschw * 3000);
END;


(*************************************************************************)
(*                                                                       *)
(*                  Gruppenanzahl zeigen                                 *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Anzahl;
BEGIN
  F_Window(26,18,53,23);
  TextColor(White);
  LowVideo;
  ClrScr;
  writeln(' Anzahl der 5er-Gruppen: ');
  write  (Anzahl:13);
END;



(*************************************************************************)
(*                                                                       *)
(*                  Lektion zeigen                                       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Lektion;
BEGIN
  F_Window(55,18,80,23);
  TextColor(White);
  LowVideo;
  ClrScr;
  write('     Lektion : ',Lektion,'      ');
END;



(*************************************************************************)
(*                                                                       *)
(*                  Abstand zwischen den 5er-Gruppen zeigen              *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Abstand;
BEGIN
  F_Window(55,13,80,18);
  TextColor(White);
  LowVideo;
  ClrScr;
  writeln('       Abstnde : ');
  case Abstand of
    1 : BEGIN gotoxy(8,3); write('  NORMAL') END;
    2 : BEGIN gotoxy(8,3); write(' DOPPELT') END;
    3 : BEGIN gotoxy(8,3); write('DREIFACH') END;
  END;
END;




(*************************************************************************)
(*                                                                       *)
(*                  gemorste 5er-Gruppen zeigen                          *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zeige_Gruppen;
var i : integer;
BEGIN
  F_Window(4,3,80,13);
  window(7,4,76,11);
  TextColor(White);
  ClrScr;
  LowVideo;
  for i:=1 to (Anzahl*5) do begin
    write(Zeichen[i]);
    if (i mod 5 = 0) and (i<400) then write('  ');
  end;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Lektionen whlen / PRG Konfigurieren                 *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Waehle_Lektion;
var Alles,Zahlen,Buchstaben,Zeichen : set of char;
{$I cwtutor.lkt }
BEGIN
  Zahlen     := ['0'..'9'] ;
  Buchstaben := ['A'..'Z'] ;
  Zeichen    := ['.','/','=','?',','] ;
  Alles      := Zahlen+Buchstaben+Zeichen;
  case Lektion of
    1  : Lektion_1;
    2  : Lektion_2;
    3  : Lektion_3;
    4  : Lektion_4;
    5  : Lektion_5;
    6  : Lektion_6;
    7  : Lektion_7;
    8  : Lektion_8;
    9  : Lektion_9;
    10 : Lektion_10;
    11 : Lektion_11;
    12 : Lektion_12;
    13 : Lektion_13;
    14 : Lektion_14;
    15 : Lektion_15;
    16 : Lektion_16;
    17 : Lektion_17;
    18 : Lektion_18;
    19 : Lektion_19;
    20 : Lektion_20;
    21 : Lektion_21;
    22 : Lektion_22;
    23 : Lektion_23;
    24 : Lektion_24;
    25 : Lektion_25;
    26 : Lektion_26;
    27 : Lektion_27;
    28 : Lektion_28;
    29 : Lektion_29;
    30 : Lektion_30;
  END;
END;

(*************************************************************************)
(*                                                                       *)
(*                   Konfiguration des Gesamtprogrammes einlesen         *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Lese_Config;
var ConfigDatei : file of integer;
    i           : integer;
BEGIN
  Assign(ConfigDatei,'CwTutor.cfg');
  {$I-}
  Reset(ConfigDatei);
  if IOResult <> 0 then BEGIN
    Frequenz := 800;
    Geschw   :=  20;
    Anzahl   :=   1;
    Abstand  :=   1;
    Lektion  :=  20;
  END
  else
  BEGIN
    read(ConfigDatei,Lektion);
    Waehle_Lektion;
    read(Configdatei,Frequenz,Abstand,Geschw,Anzahl);
    close(ConfigDatei)
  END;
  {$I+}
END;



(*************************************************************************)
(*                                                                       *)
(*                  Konfiguration des Gesamtprogrammes abspeichern       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Schreibe_Config;
var ConfigDatei : file of integer;
BEGIN
  if speichern then begin
    Assign(ConfigDatei,'CwTutor.cfg');
    {$i-}
    Rewrite(ConfigDatei);
    write(ConfigDatei,Lektion,Frequenz,Abstand,Geschw,Anzahl);
    close(ConfigDatei);
    {$I+}
  end
END;



(*************************************************************************)
(*                                                                       *)
(*                  Anfangseinstellungen vornehmen                       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Initialisieren;
var
  OrigMode : Word;
  i        : integer;
BEGIN
  speichern := False;
  CheckBreak := True;                  { auf Ctrl-Break pruefen }
  OrigMode:=LastMode;                  { mom. gesetzten Videomodus speichern }
  TextMode(Lo(LastMode));              { fuer EGA/VGA: 43 bzw. 50 Zeilen }
  TextBackground(Black);
  TextColor(Black);
  ClrScr;
  cursor_aus;
  Lese_Config;
  for i:=1 to (Anzahl*5) do Zeichen[i] := ' ';
  Zeige_Tonhoehe;
  Zeige_Geschwindigkeit;
  Zeige_Anzahl;
  Zeige_Lektion;
  Zeige_Abstand;
  Zeige_Gruppen;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Geschwindigkeit setzen                               *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Setze_Geschwindigkeit;
BEGIN
  speichern := True;
  F_Window(17,14,67,17);
  TextBackground(white);
  Textcolor(Black);
  ClrScr;
  gotoxy(3,1);
  write(' Eingabe der Gebegeschwindigkeit in WpM : ');
  Cursor_an;
  repeat
    Window(62,15,64,15);
    (*$I-*)
    read(Geschw);
    (*$I+*)
    if IOResult <> 0 then ClrScr;
    write;
  until Geschw in [5..40];
  Cursor_aus;
  window(17,14,67,17);
  TextBackground(Black);
  ClrScr;
  Zeige_Geschwindigkeit;
  Zeige_Tonhoehe;
  Zeige_Abstand;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Tonhhe setzen                                       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Setze_Tonhoehe;
BEGIN
  speichern := True;
  F_Window(17,14,63,17);
  TextBackground(white);
  Textcolor(Black);
  ClrScr;
  gotoxy(3,1);
  cursor_an;
  write(' Tonhhe der Morsezeichen in Hz : ');
  Cursor_an;
  repeat
    Window(56,15,60,15);
    (*$I-*)
    read(Frequenz);
    (*$I+*)
    if ( IOResult <> 0 ) or (Frequenz < 0) or (Frequenz > 5000)
      then ClrScr else write(Frequenz);
  until (Frequenz <= 5000) and (Frequenz>=0);
  Cursor_aus;
  window(17,14,63,17);
  TextBackground(Black);
  ClrScr;
  Zeige_Tonhoehe;
  Zeige_Abstand;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Anzahl der 5er-Gruppen setzen                        *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Setze_Anzahl;
BEGIN
  speichern := True;
  F_Window(17,14,67,17);
  TextBackground(white);
  TextColor(Black);
  ClrScr;
  gotoxy(3,1);
  write(' Anzahl der zu morsenden 5er-Gruppen : ');
  Cursor_an;
  repeat
    Window(62,15,64,15);
    (*$I-*)
    read(Anzahl);
    (*$I+*)
    if IOResult <> 0 then ClrScr else write(Anzahl);
  until Anzahl in [1..80];
  Cursor_aus;
  window(17,14,67,17);
  TextBackground(Black);
  ClrScr;
  Zeige_Tonhoehe;
  Zeige_Anzahl;
  Zeige_Abstand;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Abstand zwischen Zeichen und Gruppen setzen          *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Setze_Abstand;
var i       : integer;
    Text    : array [1..3] of string;
    eingabe : char;
BEGIN
  speichern := True;
  F_Window(20,6,59,16);
  TextBackground(white);
  Textcolor(white);
  ClrScr;
  writeln('  Abstnde zwischen Zeichen/Gruppen');
  Text[1] := '  Abstnde    - normal -';
  Text[2] := '  Abstnde   - doppelt -';
  Text[3] := '  Abstnde  - dreifach -';
  for i := 1 to 3 do BEGIN
    Textcolor(white);
    ;
    writeln;
    write('     F',i,':');
    Textcolor(Black);
    writeln(Text[i],' ');
  END;
  repeat
    eingabe := ReadKey;
    if Eingabe = #0 then BEGIN
      Eingabe := ReadKey;
      case Eingabe of
        #59 : Abstand := 1;
        #60 : Abstand := 2;
        #61 : Abstand := 3;
      END;
    END;
  until Eingabe in [#59,#60,#61];
  Window(20,6,59,16);
  Textbackground(Black);
  ClrScr;
  Zeige_Tonhoehe;
  Zeige_Gruppen;
  Zeige_Abstand;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Lektion setzen                                       *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Setze_Lektion;
var Eingabe : char;
BEGIN
  speichern := True;
  F_Window(20,14,60,17);
  TextBackground(white);
  Textcolor(Black);
  ClrScr;
  gotoxy(3,1);
  write(' Eingabe der Lektionsnummer : ');
  Cursor_an;
  repeat
    Window(54,15,56,15);
    (*$I-*)
    read(Lektion);
    (*$I+*)
    if IOResult <> 0 then ClrScr;
    write;
  until Lektion in [1..30] ;
  Cursor_aus;
  window(20,14,60,17);
  TextBackground(Black);
  ClrScr;
  Waehle_Lektion;
  Zeige_Geschwindigkeit;
  Zeige_Anzahl;
  Zeige_Tonhoehe;
  Zeige_Abstand;
  Zeige_Lektion;
END;



(*************************************************************************)
(*                                                                       *)
(*                  aktuelle 5er-Gruppen ausdrucken                      *)
(*                                                                       *)
(*************************************************************************)

FUNCTION Drucker_Bereit : integer;       { Fehlerbehandlung fr Drucken }
var regs  :registers;
    fkt,a : integer;
BEGIN                                    { blde Prozedur geht nicht richtig !! }
  regs.dx:=0;
  regs.ah := 2;
  intr($17,regs);
  a := regs.ah;
  fkt := 0;
  if (a and $20 ) <> 0 then  fkt := 2;
  if (a and $10 ) = 0 then  fkt := 1;
  Drucker_Bereit := fkt;
end;


PROCEDURE Error(Fehlerart : integer);
BEGIN
  if Fehlerart = 1 then
    BEGIN
      ClrScr;
      writeln('       kein Papier     ');
      writeln;
      write('     mehr vorhanden! ');
    END
   ELSE
    BEGIN
      ClrScr;
      writeln('       Drucker ist     ');
      writeln;
      write('      nicht bereit !  ');
    END;
  Delay(2000);
END;


PROCEDURE Drucken(Fehlerart : integer);
var i : integer;
BEGIN
  F_Window(26,13,53,18);
  TextBackGround(white);
  TextColor(white+blink);
  ClrScr;
  HighVideo;
  writeln('   5er-Gruppen werden    ');
  write('        gedruckt      ');
  if Drucker_Bereit <> 0 then
  BEGIN
    Error(Drucker_Bereit);
  END
 ELSE
  BEGIN
    writeln(lst);
    writeln(lst,'Lektion ',Lektion,' :    Geschwindigkeit : ',Geschw,
            '     Abstand : ',Abstand,'-fach');
    writeln(lst);
    for i:=1 to (Anzahl*5) do begin
      write(lst,Zeichen[i]);
      if (i mod 5 = 0) and (i<400) then write(LST,'  ');
      if (i mod 50 = 0 ) then writeln(lst);
    end;
    writeln(lst,#10);
    writeln(lst,#13);
  END;
  window(26,13,53,17);
  Textbackground(Black);
  ClrScr;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Zufallsgenerator                                     *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Zufall;
var  Zufallreal    : real;
     Zufallint,i   : integer;
BEGIN
  i := 1;
  randomize;
  repeat
    BEGIN
      Zeichen[i] := chr(Trunc(Random(122)));
      Zeichen[i]  := Upcase(Zeichen[i]);
      if Zeichen[i] in Auswahl then i := i+1;
    END;
  until i = ((Anzahl * 5)+1);
END;

Procedure Test;
var i : integer;
Begin
  i := 1;
  Repeat
    Zeichen[i]   := 'P';
    Zeichen[i+1] := 'A';
    Zeichen[i+2] := 'R';
    Zeichen[i+3] := 'I';
    Zeichen[i+4] := 'S';
    i := i+5;
  until i >= (Anzahl * 5);
END;



(*************************************************************************)
(*                                                                       *)
(*                  Langer Morseton                                      *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE lang;
BEGIN
  sound(Frequenz);
  delay(Geschwindigkeit);
  nosound;
  delay(Trunc(Geschwindigkeit/3));
END;



(*************************************************************************)
(*                                                                       *)
(*                  kurzer Morseton                                      *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE kurz;
BEGIN
  sound(Frequenz);
  delay(Trunc(Geschwindigkeit/3));
  nosound;
  delay(Trunc(Geschwindigkeit/3));
END;



(*************************************************************************)
(*                                                                       *)
(*                  Morsezeichen geben (morsen)                          *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Morsen(testmode : Boolean);
var  i :  integer;
          Eingabe : char;
BEGIN
  F_Window(26,13,53,18);
  TextBackGround(LightGray);
  TextColor(white+blink);
  ClrScr;
  HighVideo;
  writeln;
  write('    Es wird gemorst!');
  if testmode then Test else Zufall;
  delay(2000);
  TextColor(White);
  ClrScr;
  writeln;
  write(' Abbruch: Taste drcken!');
  i := 0;
  F_Window(4,3,80,13);
  window(7,4,76,11);
  TextColor(White);
  ClrScr;
  LowVideo;
  lang; kurz; lang; kurz; lang;              { Spruchanfang }
  delay (Abstand * Geschwindigkeit * 3 );
  Repeat
    i:= i+1;
    case Zeichen[i] of
      'A': BEGIN kurz; lang; END;
      'B': BEGIN lang; kurz; kurz; kurz END;
      'C': BEGIN lang; kurz; lang; kurz END;
      'D': BEGIN lang; kurz; kurz END;
      'E': kurz;
      'F': BEGIN kurz; kurz; lang; kurz END;
      'G': BEGIN lang; lang; kurz END;
      'H': BEGIN kurz; kurz; kurz; kurz END;
      'I': BEGIN kurz; kurz END;
      'J': BEGIN kurz; lang; lang; lang END;
      'K': BEGIN lang; kurz; lang END;
      'L': BEGIN kurz; lang; kurz; kurz END;
      'M': BEGIN lang; lang END;
      'N': BEGIN lang; kurz END;
      'O': BEGIN lang; lang; lang END;
      'P': BEGIN kurz; lang; lang; kurz END;
      'Q': BEGIN lang; lang; kurz; lang END;
      'R': BEGIN kurz; lang; kurz END;
      'S': BEGIN kurz; kurz; kurz END;
      'T': lang;
      'U': BEGIN kurz; kurz; lang END;
      'V': BEGIN kurz; kurz; kurz; lang END;
      'W': BEGIN kurz; lang; lang END;
      'X': BEGIN lang; kurz; kurz; lang END;
      'Y': BEGIN lang; kurz; lang; lang END;
      'Z': BEGIN lang; lang; kurz; kurz END;
      '0': BEGIN lang; lang; lang; lang; lang END;
      '1': BEGIN kurz; lang; lang; lang; lang END;
      '2': BEGIN kurz; kurz; lang; lang; lang END;
      '3': BEGIN kurz; kurz; kurz; lang; lang END;
      '4': BEGIN kurz; kurz; kurz; kurz; lang END;
      '5': BEGIN kurz; kurz; kurz; kurz; kurz END;
      '6': BEGIN lang; kurz; kurz; kurz; kurz END;
      '7': BEGIN lang; lang; kurz; kurz; kurz END;
      '8': BEGIN lang; lang; lang; kurz; kurz END;
      '9': BEGIN lang; lang; lang; lang; kurz END;
      ',': BEGIN lang; lang; kurz; kurz; lang; lang END;
      '.': BEGIN kurz; lang; kurz; lang; kurz; lang END;
      '/': BEGIN lang; kurz; kurz; lang; kurz END;
      '=': BEGIN lang; kurz; kurz; kurz; lang END;
      '?': BEGIN kurz; kurz; lang; lang; kurz; kurz END;
    END;
    LowVideo;
    write(Zeichen[i]);
    if (i mod 5 = 0) and (i<400) then write('  ');
    if i mod 5 > 0 then delay(Abstand * Geschwindigkeit)
    ELSE Delay(Abstand * Geschwindigkeit * 3);
  until (i = (Anzahl * 5)) or keypressed;
  Delay(Abstand * Geschwindigkeit * 3);
  kurz; lang; kurz; lang; kurz;             { Spruchende }
  window(26,13,53,17);
  ClrScr;
END;



(*************************************************************************)
(*                                                                       *)
(*                  untere Menueleiste auf den Moni schreiben            *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Menueleiste1;
var Text : array [1..5] of string[10];
         i    : integer;
BEGIN
  window(4,24,80,24);
  Textbackground(white);
  Text[1] := ' Morsen      ';
  Text[2] := ' Lektion     ';
  Text[3] := ' Abstand     ';
  Text[4] := ' Geschw.     ';
  Text[5] := ' Anzahl      ';
  for i := 1 to 5 do BEGIN
    Textbackground(white);
    Textcolor(black);
    write(' F',i,' ');
    HighVideo;
    Textcolor(LightCyan);
    write(Text[i],' ');
  END;
END;


(*************************************************************************)
(*                                                                       *)
(*                  obere Menueleiste auf den Moni schreiben             *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Menueleiste2;
var Text : array [6..10] of string[10];
         i    : integer;
BEGIN
  window(4,1,80,1);
  Textbackground(white);
  Text[6]  := ' CW-TUTOR    ';
  Text[7]  := ' Hilfe       ';
  Text[8]  := ' Tonhhe     ';
  Text[9]  := ' Drucken     ';
  Text[10] := ' QUIT        ';
  for i := 6 to 10 do BEGIN
    Textbackground(white);
    TextColor(black);
    write(' F',i,' ');
    HighVideo;
    Textcolor(LightCyan);
    write(Text[i],' ');
  END;
END;




(*************************************************************************)
(*                                                                       *)
(*                  CwTutor-Hilfestellung                                *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE CwTutor_Hilfe;
var Text          : Array [1..77] of string;
    Eingabe       : char;
    i,Text_Zeiger : integer;


{$I cwtutor.hlp }



PROCEDURE Page_Up;
var i : integer;
BEGIN
  If Text_Zeiger > 11 Then
  BEGIN
    TextColor(Cyan);
    ClrScr;
    Text_Zeiger := Text_Zeiger-11;
    for I := 10 downto 0 do writeln(Text[Text_Zeiger-i]);
    writeln;
    TextColor(white);
    HighVideo;
    If Text_Zeiger = 11 then
      write('                            ',#25,' PgDwn / ESC')
     ELSE
        write('                        ',#24,' PgUp  ',#25,' PgDwn / ESC');
    LowVideo;
    END;
END;


PROCEDURE Page_Down;
var i : integer;
BEGIN
  If Text_Zeiger < 77 Then
  BEGIN
    TextColor(Cyan);
    ClrScr;
    for i := 1 to 11 do writeln(Text[Text_Zeiger+i]);
    Text_Zeiger := Text_Zeiger +11;
    writeln;
    TextColor(White);
    HighVideo;
    case Text_Zeiger of
      77 : write('                             ',#24,' PgUp / ESC');
      11 : write('                             ',#25,' PgDwn / ESC');
     ELSE
        write('                        ',#24,' PgUp  ',#25,' PgDwn / ESC');
    END;
    LowVideo;
  END;
END;



BEGIN
  F_Window(5,3,79,18);
  Textbackground(LightGray);
  ClrScr;
  CWTutor_Help;
  Text_Zeiger := 0;
  Page_Down;
  Repeat
    Eingabe := ReadKey;
    If Eingabe = #0 then
    BEGIN
      Eingabe := ReadKey;
      case Eingabe of
          #81 : Page_Down;
          #73 : Page_Up;
      END;
    END;
  until Eingabe = #27;
  Window(5,3,78,17);
  Textbackground(Black);
  ClrScr;
  Zeige_Tonhoehe;
  Zeige_Abstand;
  Zeige_Gruppen;
END;



(*************************************************************************)
(*                                                                       *)
(*                  CwTutor-Infoseite                                    *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE CwTutor_Info;
var Eingabe : char;

BEGIN
  F_Window(10,3,74,17);
  Textbackground(LightGray);
  Textcolor(Cyan);
  ClrScr;
  HighVideo;
  writeln('                         MORSETUTOR');
  writeln('                   MMMMMMMMMMMMMMMMMMMMM');
  writeln('           von Georg P.-Isenbrger   DL5AAC / NZ1C');
  writeln;
  NormVideo;
  writeln('     Dieses Programm soll dazu dienen, Morsetelegrafie zu    ');
  writeln('         erlernen, oder auf Geschwindigkeit zu bringen.      ');
  writeln;
  writeln('     Auf der nchsten Seite befindet sich noch eine Hilfe !');
  TextColor(white+blink);
  HighVideo;
  writeln;
  writeln('             Dieses Programm ist PUBLIC-DOMAIN!!           ');
  writeln;
  TextColor(white);
  NormVideo;
  write('             F7: nchste Seite / Taste <Abbruch>             ');
  Eingabe := ReadKey;
  if Eingabe = #0 then begin
    Eingabe := ReadKey;
    if Eingabe = #65 then CWTutor_Hilfe;
  end;
  Window(10,3,73,17);
  Textbackground(Black);
  ClrScr;
  Zeige_Abstand;
  Zeige_Tonhoehe;
  Zeige_Gruppen;
END;


PROCEDURE CwTutor_Logo;
var Eingabe : char;

BEGIN
  F_Window(10,5,74,17);
  Textbackground(LightGray);
  Textcolor(Cyan);
  ClrScr;
  HighVideo;
  writeln('                         MORSETUTOR');
  writeln('                   MMMMMMMMMMMMMMMMMMMMM');
  writeln('           von Georg P.-Isenbrger   DL5AAC / NZ1C');
  writeln;
  NormVideo;
  writeln('     Dieses Programm soll dazu dienen, Morsetelegrafie zu    ');
  writeln('         erlernen, oder auf Geschwindigkeit zu bringen.      ');
  writeln;
  HighVideo;
  writeln('             Dieses Programm ist PUBLIC-DOMAIN!!');
  writeln;
  TextColor(white+blink);
  write('                       Taste drcken ! ');
  Repeat until Keypressed;
  NormVideo;
  Window(10,5,73,17);
  Textbackground(Black);
  ClrScr;
  Zeige_Abstand;
  Zeige_Tonhoehe;
  Zeige_Gruppen;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Auswahl von PRG-Funktionen                           *)
(*                                                                       *)
(*************************************************************************)

PROCEDURE Auswahl1;
var Eingabe        : char;
         Auswahl     : array [1..40] of char;
         Fehlerart   : integer;
BEGIN
  Cursor_aus;
  Menueleiste1;
  Menueleiste2;
  CWTutor_Logo;
  Repeat
    eingabe := ReadKey;
    if Eingabe = #0 then BEGIN
      Eingabe := ReadKey;
      case Eingabe of
          #59 : Morsen(false);
          #104: Morsen(true);
        #60 : Setze_Lektion;
          #61 : Setze_Abstand;
          #62 : Setze_Geschwindigkeit;
        #63 : Setze_Anzahl;
          #64 : CWTutor_Info;
        #65 : CWtutor_Hilfe;
          #66 : Setze_Tonhoehe;
          #67 : Drucken(Fehlerart);
      END;
    END;
  until Eingabe = #68;
  Cursor_an;
END;



(*************************************************************************)
(*                                                                       *)
(*                  Grundprogramm                                        *)
(*                                                                       *)
(*************************************************************************)

BEGIN
  Initialisieren;
  Auswahl1;
  Schreibe_Config;
  window(1,1,80,25);
  Cursor_an;
  TextBackground(Black);
  ClrScr;
END.

